#
# These functions override builtin bash commands that change directories.
#
# This script should be added to either the system wide shell initialisation
# file (/etc/profile) or a user specific initialisation file (~/.bash_profile 
# or ~/.profile). In addition, if you are using X, terminals you start up
# should be login terminals (typically -ls, --ls or something to that effect).
#

cd ()
{
	OLD="$PWD"
	{
		builtin cd "$@" 
		EXIT=$?
	} && eval `ondir "$OLD"`
	( exit $EXIT )
}

pushd ()
{
	OLD="$PWD"
	{
		builtin pushd "$@" 
		EXIT=$?
	} && eval `ondir "$OLD"`
	( exit $EXIT )
}

popd ()
{
	OLD="$PWD"
	{
		builtin popd 
		EXIT=$?
	} && eval `ondir "$OLD"`
	( exit $EXIT )
}              
