#include "String.h"
namespace str {

void wraptext(ostream &out, string const &in, unsigned indent, unsigned indented, unsigned width) {
char const *p = in.c_str();

	while (*p) {
	unsigned count = 0;

		for (count = 0; p[count] != 0 && count < (width - indent - indented); count++) ;
		// move back to last space seperation
		while (p[count] && !isspace(p[count]) && count) count--;
		if (count == 0)
		for (count = 0; p[count] != 0 && count < (width - indent - indented); count++) ;
		for (unsigned i = 0; i < count; i++) out << *p++;
		// skip spaces
		while (*p != 0 && isspace(*p)) p++;
		out << endl;
		if (*p) out << string(indent, ' ');
		indented = 0;
	}
}

string ucfirst(string const &str) {
string out;	
bool newword = true;
	
	for (string::const_iterator i = str.begin(); i != str.end(); i++)
		if (newword && isalpha(*i)) {
			out += toupper(*i);
			newword = false;
		} else {
			if (isspace(*i) || ispunct(*i)) {
				newword = true;
			}
			out += *i;
		}
	return out;
}

string exec(string const &command) {
FILE *pipe = popen(command.c_str(), "r");
char buffer[1024];
string out;

	if (!pipe) throw runtime_error("exec(): failed, " + string(sys_errlist[errno]));
	while (fgets(buffer, 1024, pipe))
		out += buffer;
	fclose(pipe);
	return out;
}

string join(string const &delim, vector<string> const &components) {
string out;
vector<string>::const_iterator end = components.end();

	end--;
	for (vector<string>::const_iterator i = components.begin(); i != components.end(); i++) {
		out += (*i);
		if (i != end)
		out += delim;
	}
	return out;
}

vector<string> split(string const &delim, string const &text) {
unsigned start = 0;
vector<string> out;

	for (unsigned i = start; i < text.size(); i++)
		if (!text.compare(delim, i, delim.size())) {
			out.push_back(text.substr(start, i - start));
			start = i + delim.size();
			i += delim.size() - 1;
		}
	out.push_back(text.substr(start));
	return out;
}

string replace(string const &match, string const &repl, string const &in) {
string out;
unsigned found = 0, lastfound = 0;

	while ((found = in.find(match, found)) != string::npos) {
		out += in.substr(lastfound, found - lastfound);
		out += repl;
		found += match.size();
		lastfound = found;
	}
	out += in.substr(lastfound);

	return out;
}

}
